onmessage = function (e) {
	console.log('Message received from main script: ' + e.data[0]);
	if ('start' == e.data[0]) {
		var navDataString = e.data[1];
		//console.log('navDataString: ' + e.data[1]);
		postMessage(["Started calculation"]);
		var routsCalculator = new RoutsCalculator();
		routsCalculator.calculateRoutingTable(navDataString);
	}

}
// creates unique id's
function uid (prefix) {
  return prefix + Math.floor((Math.random() * 100000) + 1); ;

}
function RoutsCalculator() {

	//this.navDataString = undefined;
	//	this.routingTable = undefined;
	//	this.navGraph = undefined;
	//	this.navGraph_ext = undefined;

	//	this.backbone = undefined;

	this.calculateRoutingTable = function (navDataString) {
		console.log("calculateRouts");
		this.navDataString = navDataString;
		this.createNavGraph();
		this.calculateRoutingData();
		postMessage(['finished', this.routingTable]);
	}

	this.calculateRoutingData = function () {
		var graph = new Graph(this.navGraph);
		var pathCache = {};

		this.routingTable = {};
		this.routingTableTemp = {};
		this.pathRegister = {};
		this.pathMapping = {};
		this.multiConnectPoints = {};
		var points = this.backbone['points'];
		var links = this.backbone['links'];
		var polygons = this.backbone['polygons'];
		// resolve polygons
		/*for (var keyStart in points) {
			var startNode = points[keyStart];
			var polygon_id = startNode['polygon'];
			if (polygon_id) {
				var polygonData = polygons[polygon_id];
				var linkPoints = polygonData["linkPoints"];
				for (var pkey in linkPoints) {
					//console.log("pkey= "+ pkey);
					endNode = points[pkey];
					if (pkey != keyStart) {
					var	pointLinkData ={};
					//pointLinkData[endNode.id] = 'temp';
					if(!startNode["links"]) startNode["links"]={};
					startNode["links"][endNode.id] = 'temp';
					if(!endNode["links"]) endNode["links"]={};
					endNode["links"][startNode.id] = 'temp';
					}


				}
				//console.log("graphNodeLinks pkey= "+ JSON.stringify(graphNodeLinks));
			}
		} */
		
		for (var keyPol in polygons) {
			var polygonData = polygons[keyPol];
			var linkPoints = polygonData["linkPoints"];
				for (var keyStart in linkPoints) {
					var startNode = points[keyStart];
					for (var pkey in linkPoints) {
						if(!startNode["links"] || !startNode["links"][pkey]){
						//console.log("pkey= "+ pkey);
							endNode = points[pkey];
							if (pkey != keyStart) {
								var	pointLinkData ={};
								//pointLinkData[endNode.id] = 'temp';
								var linkData={
									id : uid('pl'),
									type : 'nav-link',
									startPoint : startNode.id,
									endPoint : endNode.id,
									coord : [startNode.coord, endNode.coord]
								};
								this.backbone['links'][linkData.id]=linkData;
								if(!startNode["links"]) startNode["links"]={};
								startNode["links"][endNode.id] = linkData.id;
								if(!endNode["links"]) endNode["links"]={};
								endNode["links"][startNode.id] = linkData.id;
							}
						}

					}
				}
		}
		
		// step 1
		var step = -1;
		console.log("calculateRouts" +this.backbone['points']);
		var total = Object.keys(points).length;
		
		for (var keyStart in points) {
			step++;
			var startNode = points[keyStart];
			postMessage(["step 1: " + Math.round(step * 100 / total) + '% completed']);
			if (this.isMultiConnectNode(startNode)) this.multiConnectPoints[keyStart] = keyStart;
			if (this.isMultiConnectNode(startNode) || this.isEndNode(startNode)) {
				var nodeLinks = startNode["links"];
				for (var lkey in nodeLinks) {
					var linkID = nodeLinks[lkey];
					var linkData = links[linkID];
					if ( linkData && !linkData.pathID) {
						var path = [];
						var pathID = this.uid('P');
						this.createPathFragment(keyStart, linkData, path, pathID)
						this.pathRegister[pathID] = path;
					}
					//console.log("lkey" + lkey);
					//console.log("linkData" + JSON.stringify(linkData));
				}

			}
		}
		
		//console.log("this.pathRegister" + JSON.stringify(this.pathRegister));
		//console.log("this.pathMapping" + JSON.stringify(this.pathMapping));
		this.routingTable["pathRegister"] = this.pathRegister;
		this.routingTable["pathMapping"] = this.pathMapping;
		// step 2
		var step = -1;
		console.log("calculateRouts" +this.backbone['points']);
		var total = Object.keys(this.multiConnectPoints).length;
		
		for (var keyStart in this.multiConnectPoints) {
			step++;
			var startNode = points[keyStart];
			postMessage(["step 2: " + Math.round(step * 100 / total) + '% completed']);

			//if (this.isMultiConnectNode(startNode)) {
				for (var keyDest in this.multiConnectPoints) {
					if (!this.hasRoutingData(keyStart, keyDest)) {
						var navPath
						if (false && this.hasRoutingDataTemp(keyDest, keyStart)) {
						//console.log("found cached path"+ JSON.stringify(navPath))
						 navPath = this.routingTableTemp[keyDest][keyStart].splice().reverse();	
						} else {
						 navPath = graph.findShortestPath(keyStart, keyDest);
						 this.setRoutingDataTemp(keyStart, keyDest,navPath)
							//console.log("navPath"+ JSON.stringify(navPath))
						}
						if (navPath) {
								this.saveNavPath(keyStart, keyDest, navPath);
								//console.log(keyStart + " > " + keyDest + ": " + JSON.stringify(navPath));
						}
					}
				}
			//}
		}
		
		/*
		// step 2
		var step = -1;
		var total = Object.keys(points).length;
		for (var keyStart in points) {
			step++;
			var routingTableForStartNode = {};
			var startNode = points[keyStart];
			for (var keyDest in points) {
				postMessage(["step 2: " + Math.round(step * 100 / total) + '% completed']);

				var destNode = points[keyDest];
				if (keyStart != keyDest && !this.isMultiConnectNode(startNode) && !this.isMultiConnectNode(destNode)) {
					if (!this.hasRoutingData(keyStart, keyDest)) {
						var navPath = graph.findShortestPath(keyStart, keyDest);
						//console.log("navPath"+ navPath)
						if (navPath) {
							this.saveNavPath(keyStart, keyDest, navPath);
							//console.log(keyStart + " > " + keyDest + ": " + JSON.stringify(navPath));
							for (var skey = 0; skey < navPath.length - 1; skey++) {
								var subPathStartKey = navPath[skey];
								for (var pkey = skey + 1; pkey < navPath.length; pkey++) {
									var subPathDestKey = navPath[pkey];
									if (!this.isMultiConnectNode(points[subPathStartKey]) && !this.isMultiConnectNode(points[subPathDestKey])&& !this.hasRoutingData(subPathStartKey, subPathDestKey)) {
										var subPath = navPath.slice(skey, pkey + 1);
										//console.log('subPathDestKey:' +subPathDestKey);
										this.saveNavPath(subPathStartKey, subPathDestKey,subPath);
									}
								}
							}
						
						
							var reversePath = navPath.slice().reverse();
							this.saveNavPath(keyDest, keyStart, navPath);
								//console.log(keyStart + " > " + keyDest + ": " + JSON.stringify(navPath));
							for (var skey = 0; skey < reversePath.length - 1; skey++) {
									var subPathStartKey = reversePath[skey];
									for (var pkey = skey + 1; pkey < reversePath.length; pkey++) {
										var subPathDestKey = reversePath[pkey];
										if (!this.isMultiConnectNode(points[subPathStartKey]) && !this.isMultiConnectNode(points[subPathDestKey])&& !this.hasRoutingData(subPathStartKey, subPathDestKey)) {
											var subPath = reversePath.slice(skey, pkey + 1);
											this.saveNavPath(subPathStartKey, subPathDestKey, subPath);
									}
								}
							}
						}
						
					} 
				}

			}
		//	if(!this.isMultiConnectNode(startNode)) 
			//console.log("this.routingTable[keyStart] : " + JSON.stringify( this.routingTable));
		}
*/
	}

	this.createPathFragment = function (keyStart, linkData, path,pathID) {
		var points = this.backbone['points'];
		var links = this.backbone['links'];
		path.push(keyStart);
		//console.log("keyStart: " + keyStart)
		if(!this.pathMapping[keyStart]) this.pathMapping[keyStart] = {};
		this.pathMapping[keyStart][pathID] = pathID;
		if (linkData) {
			linkData.pathID = pathID;
			var keyNext = linkData.endPoint;
			if (keyNext==keyStart)
				keyNext = linkData.startPoint;
		//	console.log("keyNext: " + keyNext)
			var nodeNext = points[keyNext];
			if (this.isMultiConnectNode(nodeNext) || this.isEndNode(nodeNext)) {
				// finish
				this.createPathFragment(keyNext, undefined, path, pathID)
			} else {
				var nodeLinks = nodeNext["links"];
				for (var lkey in nodeLinks) {
					var linkID = nodeLinks[lkey];
					var linkDataNext = links[linkID];
					if (lkey!=keyStart ) {
						//console.log("lkey: " + lkey)
						this.createPathFragment(keyNext, linkDataNext, path , pathID)
					}
				}
			}

		}

	}
	
	this.uid  = function(prefix) {
	  return prefix + Math.floor((Math.random() * 100000) + 1); ;

	}
	this.hasRoutingData = function (keyStart, keyDest) {
		return this.routingTable[keyStart] && this.routingTable[keyStart][keyDest]
	}
	
	this.hasRoutingDataTemp = function (keyStart, keyDest) {
		return this.routingTableTemp[keyStart] && this.routingTableTemp[keyStart][keyDest]
	}
	
	this.getRoutingData = function (keyStart, keyDest) {
		if (this.routingTable[keyStart])
			return this.routingTable[keyStart][keyDest]
		else return;
	}

	this.setRoutingData = function (keyStart, keyDest, data) {
		if (!this.routingTable[keyStart])
		this.routingTable[keyStart] = {};
		this.routingTable[keyStart][keyDest] = data;

	}
	this.setRoutingDataTemp = function (keyStart, keyDest, data) {
		if (!this.routingTableTemp[keyStart])
		this.routingTableTemp[keyStart] = {};
		this.routingTableTemp[keyStart][keyDest] = data;

	}
	this.saveNavPath = function (keyStart, keyDest, navPath) {

		var pathData = {}
		var firstIntersection = this.getFirstIntersection(navPath);
		if (firstIntersection) {
			//var newPath = [];
			//newPath.push(firstIntersection);
			pathData['r'] = firstIntersection;
			//	pathData['d'] = this.getTotalDistance(navPath);
		} else {
			pathData['p'] = navPath;
			pathData['d'] = this.getTotalDistance(navPath);

		}

		this.setRoutingData(keyStart, keyDest, pathData);
	}

	this.getFirstIntersection = function (navPath) {
		var points = this.backbone['points'];
		for (var keyN in navPath) {
			var keyNav = navPath[keyN]
				if (keyN != 0 && keyN != navPath.length - 1) {
					var navNode = points[keyNav];
					if (this.isMultiConnectNode(navNode)) {
						return keyNav;
					}
				}
		}
		return;
	}

	this.isMultiConnectNode = function (node) {
		return node["links"] && Object.keys(node["links"]).length > 2;
	}
	this.isEndNode = function (node) {
		return node["links"] && Object.keys(node["links"]).length == 1;
	}
	this.calculateSharedRoutingData = function () {}

	this.getTotalDistance = function (navPath) {
		var total = 0;
		for (var i = 1; i < navPath.length; i++) {
			idStart = navPath[i - 1]
				idDest = navPath[i];
			total = total + this.navGraph_ext[idStart][idDest]['d'];

		}

		return Math.round(total * 100) / 100;
	}

	this.createNavGraph = function () {
		this.navGraph = {};
		this.navGraph_ext = {};

		this.backbone = this.navDataString;
		//navGraph = backbone['graph'];
		////console.log("backbone= "+ JSON.stringify(backbone));

		var points = this.backbone['points'];
		var polygons = this.backbone['polygons'];
		var links = this.backbone['links'];
		//var linksData = backbone['links'];
		// resolve link nodes
		for (var key in links) {
			//console.log("key=++++++++++++++++++++++++++ "+ key);

			var linkData = links[key];

			var navNodesBBL = linkData['navNodesBBL'];
			if (navNodesBBL) {
				var startPointID = linkData['startPoint'];
				var endPointID = linkData['endPoint'];
				var startPoint = points[startPointID];
				var endPoint = points[endPointID];

				for (var n in navNodesBBL) {
					var navNodeBBLID = navNodesBBL[n];
					//console.log('navNodeBBLID ' + navNodeBBLID);
					var nodeBBL = points[navNodeBBLID];
					nodeBBL['links'][startPointID] = startPointID;
					startPoint['links'][navNodeBBLID] = navNodeBBLID;

					nodeBBL['links'][endPointID] = endPointID;
					endPoint['links'][navNodeBBLID] = navNodeBBLID;
					for (var t in navNodesBBL) {
						var navNodeBBLIDTarget = navNodesBBL[t];
						//console.log('navNodeBBLIDTarget ' + navNodeBBLIDTarget);
						var nodeBBLTarget = points[navNodeBBLIDTarget];
						if (navNodeBBLID != navNodeBBLIDTarget) {
							// update links
							//console.log('navNodeBBL ' + navNodeBBLID + ">" + navNodeBBLIDTarget);
							nodeBBL['links'][navNodeBBLIDTarget] = navNodeBBLIDTarget;
							//console.log('nodeBBLTarget ' + navNodeBBLIDTarget + ">" + navNodeBBLID);
							nodeBBLTarget['links'][navNodeBBLID] = navNodeBBLID;
						}
					}
				}
			}

		}

		// calculate graph for points
		for (var key in points) {
			//console.log("key=++++++++++++++++++++++++++ "+ key);
			var id = key;
			var startNode = points[key];
			var graphNodeLinks = {};
			var graphNodeLinks_ext = {};
			// process links
			var links = startNode["links"];
			for (var lkey in links) {
				var linkData = links[lkey];
				var nodeLinkData_ext = {};
				//console.log("destid= "+ destid);
				var endNode = points[lkey];
				startCoord = startNode['coord'];
				endCoord = endNode['coord'];
				var distance = Math.sqrt(Math.pow(startCoord[0] - endCoord[0], 2) + Math.pow(startCoord[1] - endCoord[1], 2));
				graphNodeLinks[lkey] = distance;
				nodeLinkData_ext['d'] = distance;
				nodeLinkData_ext['type'] = "nav-link";
				graphNodeLinks_ext[lkey] = nodeLinkData_ext;

				//todo add special instruction etc
			}
			//console.log("graphNodeLinks lkey= "+ JSON.stringify(graphNodeLinks));
			//link to zone points
			var polygon_id = startNode['polygon'];
			if (polygon_id ){
				var polygonData = polygons[polygon_id];
				if(!polygonData['dt']){
					var linkPoints = polygonData["linkPoints"];
					for (var pkey in linkPoints) {
						//console.log("pkey= "+ pkey);
						endNode = points[pkey];
						if (pkey != key) {
							var nodeLinkData_ext = {};
							startCoord = startNode['coord'];
							endCoord = endNode['coord'];
							var distance = Math.sqrt(Math.pow(startCoord[0] - endCoord[0], 2) + Math.pow(startCoord[1] - endCoord[1], 2));
							graphNodeLinks[pkey] = distance;
							nodeLinkData_ext['d'] = distance;
							nodeLinkData_ext['polygon'] = polygon_id;
							nodeLinkData_ext['type'] = "nav-link-polygon";
							graphNodeLinks_ext[pkey] = nodeLinkData_ext;

						}
					}
				//console.log("graphNodeLinks pkey= "+ JSON.stringify(graphNodeLinks));
				}
			}

			//console.log("graphNodeLinks pkey= "+ JSON.stringify(graphNodeLinks));
			this.navGraph[id] = graphNodeLinks;
			this.navGraph_ext[id] = graphNodeLinks_ext;
		}

		//console.log("navGraph= " + JSON.stringify(this.navGraph));
		//	console.log("navGraph_ext= " + JSON.stringify(this.navGraph_ext));
	}

}
var Graph = (function (undefined) {

	var extractKeys = function (obj) {
		var keys = [],
		key;
		for (key in obj) {
			Object.prototype.hasOwnProperty.call(obj, key) && keys.push(key);
		}
		return keys;
	}

	var sorter = function (a, b) {
		return parseFloat(a) - parseFloat(b);
	}

	var findPaths = function (map, start, end, infinity) {
		infinity = infinity || Infinity;

		var costs = {},
		open = {
			'0' : [start]
		},
		predecessors = {},
		keys;

		var addToOpen = function (cost, vertex) {
			var key = "" + cost;
			if (!open[key])
				open[key] = [];
			open[key].push(vertex);
		}

		costs[start] = 0;
		while (open) {
			if (!(keys = extractKeys(open)).length)
				break;

			keys.sort(sorter);

			var key = keys[0],
			bucket = open[key],
			node = bucket.shift(),
			currentCost = parseFloat(key),
			adjacentNodes = map[node] || {};

			if (!bucket.length)
				delete open[key];

			for (var vertex in adjacentNodes) {
				if (Object.prototype.hasOwnProperty.call(adjacentNodes, vertex)) {
					var cost = adjacentNodes[vertex],
					totalCost = cost + currentCost,
					vertexCost = costs[vertex];

					if ((vertexCost === undefined) || (vertexCost > totalCost)) {
						costs[vertex] = totalCost;
						addToOpen(totalCost, vertex);
						predecessors[vertex] = node;
					}
				}
			}
		}

		if (costs[end] === undefined) {
			return null;
		} else {
			return predecessors;
		}

	}

	var extractShortest = function (predecessors, end) {
		var nodes = [],
		u = end;
		while (u) {
			nodes.push(u);
			predecessor = predecessors[u];
			u = predecessors[u];
		}

		nodes.reverse();
		return nodes;
	}

	var findShortestPath = function (map, nodes) {
		var start = nodes.shift(),
		end,
		predecessors,
		path = [],
		shortest;
		while (nodes.length) {
			end = nodes.shift();
			predecessors = findPaths(map, start, end);

			if (predecessors) {
				shortest = extractShortest(predecessors, end);
				if (nodes.length) {
					path.push.apply(path, shortest.slice(0, -1));
				} else {
					return path.concat(shortest);
				}
			} else {
				return null;
			}

			start = end;
		}
	}

	var toArray = function (list, offset) {
		try {
			return Array.prototype.slice.call(list, offset);
		} catch (e) {
			var a = [];
			for (var i = offset || 0, l = list.length; i < l; ++i) {
				a.push(list[i]);
			}
			return a;
		}
	}

	var Graph = function (map) {
		this.map = map;
	}

	Graph.prototype.findShortestPath = function (start, end) {
		if (Object.prototype.toString.call(start) === '[object Array]') {
			return findShortestPath(this.map, start);
		} else if (arguments.length === 2) {
			return findShortestPath(this.map, [start, end]);
		} else {
			return findShortestPath(this.map, toArray(arguments));
		}
	}

	Graph.findShortestPath = function (map, start, end) {
		if (Object.prototype.toString.call(start) === '[object Array]') {
			return findShortestPath(map, start);
		} else if (arguments.length === 3) {
			return findShortestPath(map, [start, end]);
		} else {
			return findShortestPath(map, toArray(arguments, 1));
		}
	}

	return Graph;

})();