// labels
var showLabelBoxOutline = false;
var styleCache={};
var labelStyle = function () {
	

	return function (feature, resolution) {
		//	console.log("feature.type " + feature.get('type') );
		//	console.log("feature.id " + feature.getId() );
			
		//console.log("resolution= " + resolution);
		if (feature.get('type') == 'text-label') {
			var color = showLabelBoxOutline ? 'rgba(0, 0, 255, 1)':'rgba(0, 0, 255, 0)'
	//	console.log("creating style= " + 'text-label');
			var style = new ol.style.Style({
					stroke : new ol.style.Stroke({
						color : color,
						width : 1
					}),
					fill : new ol.style.Fill({
						color : 'rgba(0, 0, 255, 0)'
					}),
					text : createTextStyle(feature, resolution)
					
				});
			return [style];
		}  else if (feature.get('type') == 'text-label-line') {
			var color = showLabelBoxOutline ? 'rgba(0, 0, 255, 1)':'rgba(0, 0, 255, 0)'
		//console.log("creating style= " + 'text-label-text');
		var coord = feature.getGeometry().getCoordinates();
		var start = coord[0];
		var end = coord[1];
		var x = start[0] + (end[0] - start[0]) / 2;
		var y = start[1] + (end[1] - start[1]) / 2;

		//arrow.setId('arrow');
		var dx = end[0] - start[0];
		var dy = end[1] - start[1];
		var angle = Math.atan2(dy, dx) ;
		var angleDO;
		//console.log(angleDeg);
		var angleInverted = angle * (-1)

			if (Math.sign(angleInverted) == -1) {
				angleDO = 2*Math.PI + angleInverted + Math.PI/2
			} else {
				angleDO = angleInverted +  Math.PI/2
			}

			if (angleDO > 2*Math.PI)
				angleDO = angleDO - 2*Math.PI;

		var rotation = angle;

			var style = new ol.style.Style({
					stroke : new ol.style.Stroke({
						color : color,
						width : 1
					}),
					fill : new ol.style.Fill({
						color : 'rgba(0, 0, 255, 0)'
					}),
					text : createTextStyleLine(feature, resolution, -rotation)
					
				});
		return [style];}
		else if (feature.get('type')== 'img-label') {
			//console.log("resolution= " + resolution );
				var coord = feature.getGeometry().getCoordinates();
		var start = coord[0];
		var end = coord[1];
		var x = start[0] + (end[0] - start[0]) / 2;
		var y = start[1] + (end[1] - start[1]) / 2;


		var dx = end[0] - start[0];
		var dy = end[1] - start[1];
		var angle = Math.atan2(dy, dx) ;
		
			var imgSrc='./assets/label_icons/label_default.png';
			var scale=1/(resolution);
		    if( feature.get('labelImageURL')){
					imgSrc=feature.get('labelImageURL');
			}
			if( feature.get('labelImageScale')){
	
			scale =feature.get('labelImageScale')/(resolution);
			}
			if (scale>1) scale=1
			
			var resetStyle = feature.get('resetStyle')
			if(resetStyle=='true') {
				//console.log("resetStyle " + resetStyle );
				styleCache[feature.getId()] = undefined;	
				
			} 
			
			
			var style = styleCache[feature.getId()];
			
            if(style) {
				style.getImage().setScale(scale);
				
			} else {		
				 style = new ol.style.Style({
					image : new ol.style.Icon(/** @type {olx.style.IconOptions} */
						({
							anchor : [0.5, 0.5],
							anchorXUnits : 'fraction',
							anchorYUnits : 'fraction',
							src : imgSrc,
							scale: scale 
						}))
				});
			 styleCache[feature.getId()] = style;	
				feature.set('resetStyle','false')
			}	
			style.getImage().setOpacity('1');
			var hide = feature.get('hide')
			if(hide && hide=='true') {
				style.getImage().setOpacity('0');
			}
			return style;

		}

	};
};


	 
 var createTextStyle = function(feature, resolution,rotation) {
 var text;
 if (feature.get('labelIntl'))  text = feature.get('labelIntl')[language]
 else text = feature.get('label');
 //console.log("minSize= "+ feature.get('labelIntl'));

if(!text) text='' 
	//var text ="dfgdgfsdgsdf";
 var minSize;
if(feature.getGeometry().getType()=='Circle')
	minSize = feature.getGeometry().getRadius()*2
 else   minSize = getMinimumSize(feature.getGeometry().getCoordinates())
  
  var availablePixelsPerCharacter=Math.floor(2*minSize/(resolution*text.length));
  if (availablePixelsPerCharacter > 40) availablePixelsPerCharacter=40;
  
 //  console.log("availablePixelsPerCharacter= "+ availablePixelsPerCharacter);
//console.log("minSize= "+ minSize);
 // console.log("zoom= "+ map.getView().getZoom());
// console.log("resolution"+ resolution);
  var rotationDeg='0';  
  if(rotation) rotationDeg=rotation;
  

  
   return new ol.style.Text({
    textAlign: 'center',
    textBaseline: 'middle',
    font: availablePixelsPerCharacter + 'px Verdana',
    text: getText(text, resolution, availablePixelsPerCharacter   ),
    fill: new ol.style.Fill({color: 'white'}),
    stroke: new ol.style.Stroke({color: '#666666', width: '3'}),
    offsetX: '0',
    offsetY: '0',
    rotation: rotation
  });
};

 var createTextStyleLine = function(feature, resolution,rotation) {
	 var text;
 if (feature.get('labelIntl'))  text = feature.get('labelIntl')[language]
 else text = feature.get('label');
if(!text) text='' 
	//var text ="dfgdgfsdgsdf";
 var minSize;
  minSize = getMaximumSize(feature.getGeometry().getCoordinates())
  
  var availablePixelsPerCharacter=Math.floor(2*minSize/(resolution*text.length));

  
  var presetPixelsPerCharecter =16/resolution;
 
 if(availablePixelsPerCharacter<presetPixelsPerCharecter) availablePixelsPerCharacter =1;
 else availablePixelsPerCharacter = presetPixelsPerCharecter;
 //  console.log("availablePixelsPerCharacter= "+ availablePixelsPerCharacter);
 // console.log("minSize= "+ minSize);
 // console.log("zoom= "+ map.getView().getZoom());
// console.log("resolution"+ resolution);
  var rotationDeg='0';  
  if(rotation) rotationDeg=rotation;
  
  return new ol.style.Text({
    textAlign: 'center',
    textBaseline: 'middle',
    font: availablePixelsPerCharacter + 'px Verdana',
    text: getTextLine(text, resolution, availablePixelsPerCharacter   ),
    fill: new ol.style.Fill({color: 'white'}),
    stroke: new ol.style.Stroke({color: '#666666', width: '3'}),
    offsetX: '0',
    offsetY: '0',
    rotation: rotation
  });
};

var getText = function(text, resolution,availablePixelsPerCharacter) {
  var type = 'wrap';
 
  if (availablePixelsPerCharacter < 6) {
    text = '';
  } else if (type == 'hide') {
    text = '';
  } else if (type == 'shorten') {
    text = text.trunc(12);
  } else if (type == 'wrap') {
    text = stringDivider(text, 16, '\n');
  }

  return text;
};
 var getTextLine = function(text, resolution,availablePixelsPerCharacter) {
  var type = 'wrap';
 
  if (availablePixelsPerCharacter < 6) {
    text = '';
  } else if (type == 'hide') {
    text = '';
  } else if (type == 'shorten') {
    text = text.trunc(12);
  } else if (type == 'wrap') {
    
  }

  return text;
};
 

/**
 * @param {number} n The max number of characters to keep.
 * @return {string} Truncated string.
 */
String.prototype.trunc = String.prototype.trunc ||
    function(n) {
      return this.length > n ? this.substr(0, n - 1) + '...' : this.substr(0);
    };


// http://stackoverflow.com/questions/14484787/wrap-text-in-javascript
function stringDivider(str, width, spaceReplacer) {
  if (str.length > width) {
    var p = width;
    for (; p > 0 && (str[p] != ' ' && str[p] != '-'); p--) {
    }
    if (p > 0) {
      var left;
      if (str.substring(p, p + 1) == '-') {
        left = str.substring(0, p + 1);
      } else {
        left = str.substring(0, p);
      }
      var right = str.substring(p + 1);
      return left + spaceReplacer + stringDivider(right, width, spaceReplacer);
    }
  }
  return str;
}	


function getMinimumSize(coord){
	//  console.log("minLength coord= "+ JSON.stringify(coord));
	var minLength;
	var distance;
	var firstCoord=coord[0][0];	
	for (var i = 1; i < coord[0].length; i++) {
	//console.log("coord[i]= "+ coord[i]);
			  distance=getDistanceBetweenPoints(firstCoord,coord[0][i]);
			  if(!minLength || minLength==0 ) minLength=distance
			  else if(minLength>distance && distance>0) minLength=distance
		//	  console.log("minLength= "+ minLength);
			
	}
// console.log("minLength= "+ minLength);
return minLength;
}

function getMaximumSize(coord){
	 // console.log("minLength coord= "+ JSON.stringify(coord));
	var maxLength;
	var distance;
	var firstCoord=coord[0];	
	for (var i = 1; i < coord.length; i++) {
	//console.log("coord[i]= "+ coord[i]);
			  distance=getDistanceBetweenPoints(firstCoord,coord[i]);
			  if(!maxLength || maxLength==0 ) maxLength=distance
			  else if(maxLength<distance && distance>0) maxLength=distance
			//  console.log("maxLength= "+ maxLength);
			
	}

return maxLength;
}
function getDistanceBetweenPoints(coord1,coord2){
	return Math.sqrt(Math.pow(coord1[0] - coord2[0], 2) + Math.pow(coord1[1] - coord2[1], 2));
} 