function NavItemFLayer(vectorItem, vectorHeatMap, data) {
	this.staticMarkersJSON = data.staticMarkersJSON;
	//this.pbMarkersJSON = data.pbMarkersJSON;
	this.activePBMarkersJSON = data.activePBMarkersJSON;
	this.eventsJSON = data.eventsJSON;
	this.heatmapData = data.heatmapDataJSON;
	if(!this.heatmapData ) this.heatmapData ={};
	//console.log('itemData: ' + JSON.stringify(data.heatmapDataJSON));
	//console.log('this.pbMarkersJSON ' +this.pbMarkersJSON);
	//console.log('this.activePBMarkersJSON ' +this.activePBMarkersJSON );
	this.vectorItem = vectorItem;
	this.vectorHeatMap = vectorHeatMap;
	this.boundItemsData = {};
	this.boundItemsData_Location = {};

	this.getMaxHeatmapValue = function () {

		// resolve  markers data
		if (!this.max) {

			var max = 0;
			var sum = 0;
			for (var key in this.heatmapData) {
				var itemHeatmapData = this.heatmapData[key];
				if (itemHeatmapData && itemHeatmapData['count']) {
					sum += itemHeatmapData['count'];
					if (itemHeatmapData['count'] > max)
						max = itemHeatmapData['count'];
				}

			}
			var length = Object.keys(this.heatmapData).length;
			var avg = 0;
			if (length > 0)
				avg = sum / length;
			this.max = 2 * avg;
			console.log('avg ' + avg);
		}
		return this.max;

	}

	this.loadNavItems = function () {
		if (this.staticMarkersJSON)
			this.staticItemsData = this.staticMarkersJSON;
		else
			this.staticItemsData = {};

		if (this.activePBMarkersJSON)
			this.activePBItemsData = this.activePBMarkersJSON;
		else
			this.activePBItemsData = {};

		// resolve  markers data

		for (var key in this.staticItemsData) {
			var itemData = this.staticItemsData[key];
			if (itemData["location_id"]) {
				//console.log('itemData["location_id"]: ' + itemData["location_id"]);
				var activeItemData = this.activePBItemsData[itemData["location_id"]];
				if (activeItemData) {
					var completeMarkerData = $.extend(true, {}, itemData, activeItemData)
						//	completeMarkerData.id = itemData.id;
						//	console.log('itemData: ' + JSON.stringify(itemData));
						//	console.log('activeItemData: ' + JSON.stringify(activeItemData));
						//	console.log('completeMarkerData: ' + JSON.stringify(completeMarkerData));

						this.loadMarkerData(completeMarkerData);
					this.boundItemsData_Location[itemData["location_id"]] = completeMarkerData;
				} else {
					this.loadMarkerData(itemData);
				}
			} else {
				this.loadMarkerData(itemData);
			}
		}

	}

	this.loadMarkerData = function (itemData) {
		this.boundItemsData[itemData.id] = itemData;
			if (itemData['marker_type'] == 'general') {
				itemData['marker_type'] = itemData['marker_type'] +"_tour";
			}
			if (itemData['marker_type'] == 'general-small') {
				itemData['marker_type'] = itemData['marker_type'] +"_tour";
			}
			if(itemData['auxData']=='tour'){
				itemData['marker_type'] = itemData['marker_type'] +"_tour";
			}
		if (!itemData['popupPreviewURL']) {
			var marker_type = itemData['marker_type'];
			itemData['popupPreviewURL'] = markerStyles[marker_type]['default_preview']
		}
		if (itemData['gType'] == 'Point') {
			//console.log('loadPoint ');

			var marker = createIconMarker(itemData['coord'], itemData['id'], itemData['id'], itemData['marker_type']);
			marker.setId(itemData['id']);

			//marker.setStyle(iconMarkerStyle);
			vectorItem.getSource().addFeature(marker);
			itemData['feature'] = marker;

		}

		if (itemData['popupHeadingIntl'])
			itemData['popupHeading'] = itemData['popupHeadingIntl'][language]
				if (itemData['popupTextIntl'])
					itemData['popupText'] = itemData['popupTextIntl'][language]

						// heatmap
						var itemHeatmapData = this.heatmapData[itemData['id']];
				var weight = 0;
		itemData['count'] = 0;
		//console.log(this.getMaxHeatmapValue());
		if (itemHeatmapData && itemHeatmapData['count'] && this.getMaxHeatmapValue() > 0) {
			weight = itemHeatmapData['count'] / this.getMaxHeatmapValue();
			itemData['count'] = itemHeatmapData['count']
		}

		//console.log('weight ' + weight);
		//if(weight<0.5) weight =0.5;
		var geoMarker = new ol.Feature({
				geometry: new ol.geom.Point(itemData['coord']),
				name: name,
				weight: weight

			});
		itemData['hm_feature'] = geoMarker;
		vectorHeatMap.getSource().addFeature(geoMarker);
		itemData['hm_added'] = true;

	}

	this.getDistance = function (coord1, coord2) {
		return Math.sqrt(Math.pow(coord1[0] - coord2[0], 2) + Math.pow(coord1[1] - coord2[1], 2));
	}

	this.getDistanceSqr = function (coord1, coord2) {
		return Math.pow(coord1[0] - coord2[0], 2) + Math.pow(coord1[1] - coord2[1], 2);
	}

	this.createTempLink = function (coord1, coord2) {
		var linkFeature =
			new ol.Feature({
				type: 'temp-link',
				geometry: new ol.geom.LineString([coord1, coord2]),

			});
		return linkFeature;
	}

	this.createTempNode = function (coord1) {
		var linkFeature =
			new ol.Feature({
				type: 'temp-node',
				geometry: new ol.geom.LineString(coord1),

			});
		return linkFeature;
	}

	this.searchByTerm = function (term) {
		var regExpr = new RegExp(term, "i");
		console.log(regExpr);
		// search static and dynamic markers
		var items = [];
		for (var key in this.boundItemsData) {
			var itemData = this.boundItemsData[key];
			var selected = false;
			if (itemData['popupHeading']) {
				if (itemData['popupHeading'].search(regExpr) != -1)
					selected = true;

			}
			if (itemData['popupText']) {
				if (itemData['popupText'].search(regExpr) != -1)
					selected = true;
			}
			if (itemData['marker_type']) {
				if (itemData['marker_type'].search(regExpr) != -1)
					selected = true;

			}
			if (selected) {
				items.push(itemData);
			}
		}

		// search events - implement;
		this.sortHits = this.sortHits(final_items);	

		return {
			'items': items
		}

	}

	this.searchByType = function (typeOptions, strict, keyword) {
		//console.log(regExpr);
		// search static and dynamic markers
		var regexCache = {};
		var items = [];
		for (var key in this.boundItemsData) {
			var itemData = this.boundItemsData[key];
			var selected = false;
			if (itemData['marker_type']) {
				for (var keyType in typeOptions) {
					var type = typeOptions[keyType];
					if (strict) {

						if (itemData['marker_type'] == type)
							selected = true;
					} else {
						var regExpr = regexCache[type];
						if (!regExpr) {
							regExpr = new RegExp(type, "i");
							regexCache[type] = regExpr;
						}
						if (itemData['marker_type'].search(regExpr) != -1)
							selected = true;
					}

				}
			}
			if (selected) {
				items.push(itemData);
			}
		}
		//console.log("items " + items);
		var final_items = items;
		if (keyword) {
			final_items = [];
			var regExpr = new RegExp(keyword, "i");
			var final_items = [];
			for (var key in items) {
				var itemData = items[key];
				var selected = false;
				if (itemData['popupHeading']) {
					if (itemData['popupHeading'].search(regExpr) != -1)
						selected = true;

				}
				if (itemData['popupText']) {
					if (itemData['popupText'].search(regExpr) != -1)
						selected = true;
				}
				if (itemData['marker_type']) {
					if (itemData['marker_type'].search(regExpr) != -1)
						selected = true;

				}
				if (selected) {
					final_items.push(itemData);
				}
			}

		}

		final_items= this.sortHits(final_items);
		return {
			'items': final_items
		}

	}
	this.sortAZ = function (array) {
		return array.sort(function (a, b) {
			var nameA = a.popupHeading.toLowerCase(),
			nameB = b.popupHeading.toLowerCase();
			if (nameA < nameB) //sort string ascending
				return -1;
			if (nameA > nameB)
				return 1;
			return 0; //default return value (no sorting)
		});

	}

	this.sortDistance = function (array) {
		return array.sort(function (a, b) {
			var distA = navigatorCore.findDistanceToItem(a['id']);
			var distB = navigatorCore.findDistanceToItem(b['id']);
			if (distA < distB) //sort string ascending
				return -1;
			if (distA > distB)
				return 1;
			return 0; //default return value (no sorting)
		});

	}
	
	this.sortHits = function (array) {
		return array.sort(function (a, b) {
			var distA = a['count'];
			var distB = b['count'];
			if (distA > distB) //sort string ascending
				return -1;
			if (distA <distB)
				return 1;
			return 0; //default return value (no sorting)
		});

	}
}