function Navigator(options, vectorLabels, vectorGrid, vectorNav, vectorLocation, vectorItem, vectorLayerHeatMap, mapMetersPerCoordinatePoint, data) {
	this.vectorLabels = vectorLabels;
	this.vectorGrid = vectorGrid;
	this.vectorNav = vectorNav;
	this.vectorLocation = vectorLocation;
	this.vectorItem = vectorItem;
	this.vectorHeatMap = vectorLayerHeatMap;
	this.mapMetersPerCoordinatePoint = mapMetersPerCoordinatePoint;
	this.aproachingNode = options.aproachingNode;
	this.onPath = options.onPath;
	this.avarageWalkingSpeed = options.avarageWalkingSpeed;
	this.orientationTrigger = options.orientationTrigger;
	this.positioningMode = options.positioningMode
		this.lookRadius = options.lookRadius;
	this.navigatorCore = this;
	this.navBackboneJSON = data.backboneJSON;
	this.routingTableJSON = data.routingJSON;
	this.labelsJSON = data.labelsJSON;
	this.heatmapData= data.heatmapDataJSON;


	this.initNavigator = function () {
		//console.log(this.labelsJSON);
		if (this.labelsJSON)
			this.loadLabels(this.labelsJSON);
		//	this.navBackboneFLayer = new NavBackboneFLayer(this.vectorGrid, this.navBackboneJSON);
		//	this.navBackboneFLayer.loadNavBackbone();
		this.navItemFLayer = new NavItemFLayer(this.vectorItem,this.vectorHeatMap, data);
		this.navItemFLayer.loadNavItems();
		//this.navPathAssistant = new NavPathAssistant(this.navigatorCore, this.vectorNav);
		//	this.loadRoutingTable();
		//this.locationManager = new LocationManager(this.navigatorCore)
		//this.locationManager.setPSType(this.positioningMode);
		//	this.userLocationDisplay = new UserLocationDisplay(this.navigatorCore, this.vectorLocation);
		//	this.orientationManager = new OrientationManager(this.navigatorCore)
		//this.orientationManager.setAutoRotateMap(true);
		//	this.lookAssistant = new LookAssistant(this.navigatorCore);

	};

	this.loadRoutingTable = function () {
		this.routingTable = this.routingTableJSON;
	};

	this.loadLabels = function (labelsJSON) {

		var labelsData = labelsJSON;
		var labelView;
		for (var key in labelsData) {
			//console.log("key= " + key);
			var labelData = labelsData[key];
			if (labelData.type == "text-label") {
				//console.log("labelData.type= "+ labelData.type)
				labelView = this.createPolygonLabel(labelData);
				this.vectorLabels.getSource().addFeature(labelView);

			} else if (labelData.type == "img-label") {
				//	console.log("labelData.type= "+ labelData.type)
				labelView = this.createIconLabel(labelData);
				this.vectorLabels.getSource().addFeature(labelView);

			}
			if (labelData.type == "text-label-line") {
				//console.log("labelData.type= "+ labelData.type)
				labelView = this.createLineLabel(labelData);
				this.vectorLabels.getSource().addFeature(labelView);

			}

		}

	}

	this.createPolygonLabel = function (labelData) {
		var polygon = new ol.geom.Polygon(labelData['coord']);
		var nodeFeature =
			new ol.Feature({
				type: 'text-label',
				geometry: polygon,
				label: labelData['label'],
				labelIntl: labelData['labelIntl'],
			});
		return nodeFeature;
	}
	this.createLineLabel = function (labelData) {
		var line = new ol.geom.LineString(labelData['coord']);
		var nodeFeature =
			new ol.Feature({
				type: 'text-label-line',
				geometry: line,
				label: labelData['label'],
				labelIntl: labelData['labelIntl'],
			});
		return nodeFeature;
	}
	this.createIconLabel = function (labelData) {
		var iconLabel = new ol.Feature({
				type: 'img-label',
				geometry: new ol.geom.Point(labelData['coord']),
				labelImageURL: labelData['labelImageURL'],
				labelImageScale: labelData['labelImageScale']
			});
		iconLabel.setId(labelData['id']);
		return iconLabel;
	}

	this.getDistanceMeteres = function (coord1, coord2) {
		return Math.round(Math.sqrt(Math.pow(coord1[0] - coord2[0], 2) + Math.pow(coord1[1] - coord2[1], 2)) * navigatorCore.mapMetersPerCoordinatePoint);
	}

	this.getDistance = function (coord1, coord2) {
		return Math.round(Math.sqrt(Math.pow(coord1[0] - coord2[0], 2) + Math.pow(coord1[1] - coord2[1], 2)));
	}



}