var featuresLoadCache;
// load nav layerX

var  pathStrokes={};
pathStrokes.none = new ol.style.Stroke({
			color : 'rgba(0, 0, 255, 1)',
			width : 4
		})	
		
pathStrokes[1] = new ol.style.Stroke({
			color : 'rgba(0, 255, 0, 1)',
			width : 4
		})			

		pathStrokes[2] = new ol.style.Stroke({
				color : 'rgba(255, 0, 0, 1)',
				width : 4
			})
var bStyleCache={};

var backboneStyle = function () {

	return function (feature, resolution) {
		//	console.log("feature.type " + feature.get('type') );
		//	console.log("feature.id " + feature.getId() );


		if (feature.get('type') == 'nav-node') {
			var style = bStyleCache[feature.getId()];
			if (!style) {
				style = new ol.style.Style({
						image : new ol.style.Circle({
							radius : 9,
							fill : new ol.style.Fill({
								color : 'rgba(0, 0, 255, 1)'
							}),
							stroke : new ol.style.Stroke({
								color : 'rgba(0, 0, 255, 1)',
								width : 2
							})
						})
					});
				bStyleCache[feature.getId()] = style;
			}
			return style;
		} else if (feature.get('type') == 'nav-node-bbl') {
			var style = bStyleCache[feature.getId()];
			if (!style) {
				style = new ol.style.Style({
					image : new ol.style.Circle({
						radius : 9,
						fill : new ol.style.Fill({
							color : 'rgba(255, 255, 255, 1)'
						}),
						stroke : new ol.style.Stroke({
							color : 'rgba(0, 0, 255 , 1)',
							width : 2
						})
					})
				});
				bStyleCache[feature.getId()] = style;
			}
			return style;
		} else if (feature.get('type') == 'nav-link') {

			var style = bStyleCache[feature.getId()];
			if (!style) {
				style = new ol.style.Style({
						stroke : new ol.style.Stroke({
							color : 'rgba(0, 0, 255, 1)',
							width : 5
						})
					});
				bStyleCache[feature.getId()] = style;
			}
			var ex_path_types = feature.get('ex_path_types');
			if(ex_path_types){
				if (ex_path_types[1] && ex_path_types[2]) style.getStroke().setColor('rgba(0, 0, 0, 1)')
				else if (ex_path_types[1]) style.getStroke().setColor('rgba(0, 255, 0, 1)')
				else if (ex_path_types[2]) style.getStroke().setColor('rgba(191, 63, 191,1)')
			} else {
				style.getStroke().setColor('rgba(0, 0, 255, 1)')
			}
			
			return style;

		} else if (feature.get('type') == 'nav-node-polygon') {
			var style = bStyleCache[feature.getId()];
			if (!style) {
				style = new ol.style.Style({
						stroke : new ol.style.Stroke({
							color : 'rgba(0, 0, 255, 1)',
							width : 1

						}),
						fill : new ol.style.Fill({
							color : 'rgba(0, 0, 255, 0.2)'
						})
					});
				bStyleCache[feature.getId()] = style;
			}
			
			var ex_path_types = feature.get('ex_path_types');
			if(ex_path_types){
				if (ex_path_types[1] && ex_path_types[2]) style.getStroke().setColor('rgba(0, 0, 0, 1)')
				else if (ex_path_types[1]) style.getStroke().setColor('rgba(0, 255, 0, 1)')
				else if (ex_path_types[2]) style.getStroke().setColor('rgba(191, 63, 191,1)')
			} else {
				style.getStroke().setColor('rgba(0, 0, 255, 1)')
			}
			return style;
			
		} else if (feature.get('type') == 'connect-node-bbl') {

			var style = bStyleCache[feature.getId()];
			if (!style) {
				style = new ol.style.Style({
						image : new ol.style.Circle({
							radius : 9,
							fill : new ol.style.Fill({
								color : 'rgba(255, 255, 255, 1)'
							}),
							stroke : new ol.style.Stroke({
								color : 'rgba(0, 255, 0 , 1)',
								width : 2
							})
						})
					});
				bStyleCache[feature.getId()] = style;
			}
			return style;
		}
	}
};


var featuresLoadCache;
function loadNavLayer(s, vectorSource) {
	featuresLoadCache = {};
	var backbone = s;
	if (typeof s === 'string')
		backbone= JSON.parse(s);
	
	//navGraph = backbone['graph'];
	//console.log("backbone= "+ JSON.stringify(backbone));
	var points = backbone['points'];
	var polygons = backbone['polygons'];
	var links = backbone['links'];

	//load points
	for (var key in points) {
		var pointData = points[key];
		pointData['id'] = key;
		var navNodeFeature = createNavNodeFeature(pointData,vectorSource);
		if(navNodeFeature.get('polygon')){
		//console.log("node in polygon key= "+ key);	
			
		}
		featuresLoadCache[key] = navNodeFeature;
		if(navNodeFeature.get('polygon')){
		//console.log("cached polygon node key= "+ key);	
			
		}
	}

	//load polygons
	for (var key in polygons) {
		////console.log("pkey= "+ pkey);
		polygonData = polygons[key];
		polygonData['id'] = key;
		var navNodePolygon = createNavNodePolygonFeature(polygonData,vectorSource);
		featuresLoadCache[key] = navNodePolygon;
		var ex_path_types = polygonData['ex_path_types'];
			if(ex_path_types) {
				//console.log("ex_path_types: " +ex_path_types)
				navNodePolygon.set('ex_path_types',ex_path_types);
			}
			
		var linkPoints = polygonData["linkPoints"];
		for (var pkey in linkPoints) {
			//console.log("pkey= "+ pkey);
			var linkedNavNode = featuresLoadCache[pkey];
			//console.log("linkedNavNode= "+ linkedNavNode['id']);
			if (!navNodePolygon['linkPoints'])
				navNodePolygon['linkPoints'] = [];
			navNodePolygon['linkPoints'].push(linkedNavNode);
			if (!linkedNavNode['polygon_id']){
				linkedNavNode['polygon_id'] =key;
			}
		}
	}

	for (var key in points) {
		navNodeFeature = featuresLoadCache[key];
		if(navNodeFeature['polygon_id']){
		//console.log("cached polygon node key= "+ key);	
		navNodeFeature['polygon']=featuresLoadCache[navNodeFeature['polygon_id']];	
		}
	}
	
	
	for (var key in links) {
		var linkData = links[key];
		linkData['id'] = key;
		var navLink = createNavLinkFeature(linkData,vectorSource);
		
		var ex_path_types = linkData['ex_path_types'];
			if(ex_path_types) {
				//console.log("ex_path_types: " +ex_path_types)
				navLink.set('ex_path_types',ex_path_types);
			}
			
			
		var startPoint = featuresLoadCache[linkData['startPoint']];
		navLink['startPoint'] = startPoint;
		if (startPoint.get("type") == "nav-node-bbl") {
			startPoint["connectLink"] = navLink;
		}
		if (!startPoint['links'])
			startPoint['links'] = [];
		startPoint['links'].push(navLink);

		var endPoint = featuresLoadCache[linkData['endPoint']];
		navLink['endPoint'] = endPoint;

		if (endPoint.get("type") == "nav-node-bbl") {
			endPoint["connectLink"] = navLink;
		}
		if (!endPoint['links'])
			endPoint['links'] = [];
		endPoint['links'].push(navLink);

		var navNodesBBL = linkData["navNodesBBL"];
		if (navNodesBBL) {
			for (var lkey in navNodesBBL) {
				
				var destNavNodeFeature = featuresLoadCache[lkey];
				if(!destNavNodeFeature)
				console.log("lkey= "+ lkey);
				
				if (!navLink['navNodesBBL']) {
					navLink['navNodesBBL'] = [];
				}
				navLink['navNodesBBL'].push(destNavNodeFeature);
				destNavNodeFeature['hostLink'] = navLink;
			}
		}

		featuresLoadCache[key] = navLink;

	}

}

function isNavPolygon(feature) {
	return feature && feature.get("type") == "nav-node-polygon";
}
function isLinkBBN(feature) {
	return feature && feature.get("type") == "link-bbn";
}
function isNavConnectNode(feature) {
	return feature && feature.get("type") == "nav-node-bbl";
}

function createNavNodeFeature(pointData,vectorSource) {

	var point = new ol.geom.Point(pointData['coord']);
	var nodeFeature =
		new ol.Feature({
			type : pointData['type'],
			geometry : point,
			name : pointData['label']
		});
	nodeFeature.setId(pointData['id']);
	
	if(pointData['polygon']){
	//console.log('feature with polygon id: ' + pointData['id']);
	//console.log('polygon: ' + pointData['polygon']);
	 nodeFeature['polygon_id'] = pointData['polygon'];
	
	}
	//if (isNavConnectNode(nodeFeature))
	//	nodeFeature.setStyle(navNodeBBLPointStyle);
//	else
	//	nodeFeature.setStyle(navNodeStyle);
	vectorSource.addFeature(nodeFeature);
	return nodeFeature;
}

function createNavNodePolygonFeature(polygonData,vectorSource) {

	var polygon = new ol.geom.Polygon(polygonData['coord']);
	var nodeFeature =
		new ol.Feature({
			type : 'nav-node-polygon',
			geometry : polygon,
			name : polygonData['label']
		});

	nodeFeature.setId(polygonData['id']);
	nodeFeature.set('dt',polygonData['dt']);
//	nodeFeature.setStyle(navPolygonStyle);
	vectorSource.addFeature(nodeFeature);
	return nodeFeature;
}

function createNavLinkFeature(linkData,vectorSource) {

	var linkFeature =
		new ol.Feature({
			type : 'nav-link',
			geometry : new ol.geom.LineString(linkData['coord']),
			name : linkData['label']
		});
	linkFeature.setId(linkData['id']);
  //linkFeature.setStyle(navConnectionLinkStyle);
	vectorSource.addFeature(linkFeature);
	return linkFeature;
}

function loadLabelsLayer(s, vectorSource) {
	////console.log('load: ' + s);
	var boundItemsData = s;
	if (typeof s === 'string')
		boundItemsData= JSON.parse(s);
	for (var key in boundItemsData) {
		var itemData = boundItemsData[key];
		deserialiseLabelItem(itemData, vectorSource);
	}

}

function deserialiseLabelItem(itemData, vectorSource) {
	if (itemData['type'] == 'img-label') {
		//	//console.log('loadPoint ');
		var point = new ol.geom.Point(itemData['coord']);
		var nodeFeature =
			new ol.Feature({
				id : itemData['id'],
				type : 'img-label',
				geometry : point,
				label : itemData['label']
			});
		nodeFeature.setId(itemData['id']);
		nodeFeature.set('gType', itemData['gType']);
		nodeFeature.set('popupPreviewURL', itemData['popupPreviewURL']);
		nodeFeature.set('popupHeading', itemData['popupHeading']);
		nodeFeature.set('popupText', itemData['popupText']);
		nodeFeature.set('labelImageURL', itemData['labelImageURL']);
		//nodeFeature.setStyle(iconMarkerStyle);
		vectorSource.addFeature(nodeFeature);

		// expand bindings

		var links_bbn = itemData['links-bbn'];
		if (links_bbn)
			expandBindingsForPoint(nodeFeature, links_bbn);

	} else if (itemData['type'] == 'text-label') {

		////console.log('load Polygon ');
		var polygon = new ol.geom.Polygon(itemData['coord']);
		var nodeFeature =
			new ol.Feature({
				id : itemData['id'],
				type : 'text-label',
				geometry : polygon,
				label : itemData['label']

			});
		nodeFeature.setId(itemData['id']);
		nodeFeature.set('gType', itemData['gType']);
		nodeFeature.set('popupPreviewURL', itemData['popupPreviewURL']);
		nodeFeature.set('popupHeading', itemData['popupHeading']);
		nodeFeature.set('popupText', itemData['popupText']);
		nodeFeature.set('labelImageURL', itemData['labelImageURL']);
		vectorSource.addFeature(nodeFeature);

		// expand bindings

		var links_bbn = itemData['links-bbn'];
		if (links_bbn)
			bindLinkEditor.expandBindingsForPolygon(nodeFeature, links_bbn);

	}
}

function loadStaticMarkersLayer(s, vectorSource) {
	//	console.log('load: ' + s);
	var boundItemsData = s;
	if (typeof s === 'string')
		boundItemsData= JSON.parse(s);
	for (var key in boundItemsData) {
		var itemData = boundItemsData[key];
		
		// temp
		//if (itemData.type='img-label') {
			
		//itemData.type='pb-marker';
      //  itemData['popupPreviewURL']=itemData['labelImageURL']		
		//itemData['popupHeading']="ph"+itemData['labelImageURL']
		//itemData['marker_type']='general'
	//	deserialiseMarkerItem(itemData, vectorSource);
	//	}
		
		
		//itemData['popupHeading']=itemData['popupHeading']+"ph";
		deserialiseMarkerItem(itemData, vectorSource);
	}

}

function deserialiseMarkerItem(itemData, vectorSource) {

	//console.log('loadPoint ' +itemData['gType']);
if ((itemData['type'] == 'st-marker' || itemData['type'] == 'pb-marker'  ) && itemData['gType'] == "Point") {
		//console.log('loadPoint ');
		var point = new ol.geom.Point(itemData['coord']);
		var nodeFeature =
			new ol.Feature({
				id : itemData['id'],
				type : itemData['type'],
				geometry : point,
			});
			
		//itemData['popupHeadingIntl']={};
		//itemData['popupHeadingIntl']['en'] = itemData['popupHeading']
		//itemData['popupHeadingIntl']['zh_Hans'] = itemData['popupHeading'] + ' ChHans'	
		
		//itemData['popupTextIntl']={};
	//	itemData['popupTextIntl']['en'] = itemData['popupHeading']
	//	itemData['popupTextIntl']['zh_Hans'] = itemData['popupHeading'] + ' ChHans'	
			
		nodeFeature.setId(itemData['id']);
		nodeFeature.set('gType', itemData['gType']);
		nodeFeature.set('popupPreviewURL', itemData['popupPreviewURL']);
		nodeFeature.set('popupHeading', itemData['popupHeading']);
	    nodeFeature.set('popupHeadingIntl', itemData['popupHeadingIntl']);
		nodeFeature.set('popupText', itemData['popupText']);
	    nodeFeature.set('popupTextIntl', itemData['popupTextIntl']);
		nodeFeature.set('marker_type', itemData['marker_type']);
		nodeFeature.set('location_id', itemData['location_id']);
		

		vectorSource.addFeature(nodeFeature);
		
		
		// temp

		
		// expand bindings

		var links_bbn = itemData['links-bbn'];
		if (links_bbn)
			expandBindingsForPoint(nodeFeature, links_bbn);

	} else if ((itemData['type'] == 'st-marker' || itemData['type'] == 'pb-marker'  ) && itemData['gType'] == "Polygon") {

		////console.log('load Polygon ');
		var polygon = new ol.geom.Polygon(itemData['coord']);
		var nodeFeature =
			new ol.Feature({
				id : itemData['id'],
				type : itemData['type'],
				geometry : polygon,

			});
		nodeFeature.setId(itemData['id']);
		nodeFeature.set('gType', itemData['gType']);
		nodeFeature.set('popupPreviewURL', itemData['popupPreviewURL']);
		nodeFeature.set('popupHeading', itemData['popupHeading']);
		nodeFeature.set('popupHeadingIntl', itemData['popupHeadingIntl']);
		nodeFeature.set('popupText', itemData['popupText']);
		nodeFeature.set('popupTextIntl', itemData['popupTextIntl']);
		nodeFeature.set('marker-type', itemData['marker-type']);
		nodeFeature.set('location_id', itemData['location_id']);
		vectorSource.addFeature(nodeFeature);

		// expand bindings

		var links_bbn = itemData['links-bbn'];
		if (links_bbn)
			expandBindingsForPolygon(nodeFeature, links_bbn);

	}
}


function loadPMarkersLayer(s, vectorSource) {
	//	console.log('load: ' + s);
	var boundItemsData = s;

	for (var key in boundItemsData) {
		var itemData = boundItemsData[key];
		deserialiseMarkerItem(itemData, vectorSource);
	}

}

function expandBindingsForPoint(pointFeature, links_bbn) {
	for (var key in links_bbn) {
		var linkData = links_bbn[key];
		if (linkData["type"] == "link-bbn") {
			var destinationPoint_id = linkData["destNode"];
			var destNodeFeature = featuresLoadCache[destinationPoint_id];
			bindLinkEditor.selectStartPointAndStartConnection(destNodeFeature, pointFeature.getGeometry().getCoordinates());
			bindLinkEditor.createConnectionToPoint(pointFeature);

		} else if (linkData["type"] == "connect-node-bbl") {
			var coord = linkData["coord"];
			var hostLink_id = linkData['hostLink'];
			// get link
			var link = featuresLoadCache[hostLink_id];
			if (link) {
				bindLinkEditor.selectStartLinkPointAndStartConnection(link, coord)
				bindLinkEditor.createConnectionToPoint(pointFeature);
			}
		}
	}

}

function expandBindingsForPolygon(polygonFeature, links_bbn) {
	for (var key in links_bbn) {
		var linkData = links_bbn[key];
		if (linkData["type"] == "link-bbn") {
			var destinationPoint_id = linkData["destNode"];
			var destNodeFeature = featuresLoadCache[destinationPoint_id];
			bindLinkEditor.selectStartPointAndStartConnection(destNodeFeature, polygonFeature.getGeometry().getInteriorPoint().getCoordinates());
			bindLinkEditor.createConnectionToPolygon(polygonFeature);

		} else if (linkData["type"] == "connect-node-bbl") {
			var coord = linkData["coord"];
			var hostLink_id = linkData['hostLink'];
			// get link

			var link = featuresLoadCache[hostLink_id];
			if (link) {
				bindLinkEditor.selectStartLinkPointAndStartConnection(link, coord)
				bindLinkEditor.createConnectionToPolygon(polygonFeature);
			}
		}
	}

}